"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.userPropertiesValidation = void 0;
const CommonFunctions = __importStar(require("../common-functions/common-functions"));
const Messages = __importStar(require("./console-messages"));
class ApplicationPropertiesValidation {
    checkReportGenerationParameters(reportGenerationParameters) {
        if (!reportGenerationParameters) {
            throw new Error(Messages.optionsNotProvided);
        }
        CommonFunctions.checkFolder(reportGenerationParameters.jsonDir);
        return this.initializeReportGenerationParameters(reportGenerationParameters);
    }
    initializeReportGenerationParameters(reportGenerationParameters) {
        reportGenerationParameters.mongooseServerUrl = reportGenerationParameters.mongooseServerUrl ?? 'http://localhost:3000';
        reportGenerationParameters.reportTitle = reportGenerationParameters.reportTitle ?? 'Cucumber HTML Report Generator';
        reportGenerationParameters.reportPath = CommonFunctions.initializePath(reportGenerationParameters.reportPath);
        return reportGenerationParameters;
    }
    initializeReportDisplayParameters(reportConfigurationParameters) {
        const localReportDisplayParameters = reportConfigurationParameters ?? {};
        localReportDisplayParameters.theme = localReportDisplayParameters.theme === 'Light' ? localReportDisplayParameters.theme : 'Dark';
        localReportDisplayParameters.reportPath = CommonFunctions.initializePath(localReportDisplayParameters.reportPath);
        return localReportDisplayParameters;
    }
}
exports.userPropertiesValidation = new ApplicationPropertiesValidation();
//# sourceMappingURL=application-properties-validation.js.map